Restore vpp-gcc-verify* job 91/39291/1
authorDave Wallace <dwallacelf@gmail.com>
Fri, 28 Jul 2023 20:49:43 +0000 (16:49 -0400)
committerDave Wallace <dwallacelf@gmail.com>
Fri, 28 Jul 2023 20:49:43 +0000 (16:49 -0400)
- otherwise gcc build breakage will kill vpp-cov daily job.

Change-Id: I72effa7725d2e0cd3fadcfc6a359f24f372ba80c
Signed-off-by: Dave Wallace <dwallacelf@gmail.com>
jjb/scripts/vpp/gcc-build.sh [new file with mode: 0644]
jjb/vpp/vpp.yaml

diff --git a/jjb/scripts/vpp/gcc-build.sh b/jjb/scripts/vpp/gcc-build.sh
new file mode 100644 (file)
index 0000000..1d81600
--- /dev/null
@@ -0,0 +1,78 @@
+#!/bin/bash
+
+# Copyright (c) 2022 Cisco and/or its affiliates.
+# Licensed under the Apache License, Version 2.0 (the "License");
+# you may not use this file except in compliance with the License.
+# You may obtain a copy of the License at:
+#
+#     http://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing, software
+# distributed under the License is distributed on an "AS IS" BASIS,
+# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+# See the License for the specific language governing permissions and
+# limitations under the License.
+
+echo "---> jjb/scripts/vpp/gcc-build.sh"
+
+set -euxo pipefail
+
+line="*************************************************************************"
+OS_ID=$(grep '^ID=' /etc/os-release | cut -f2- -d= | sed -e 's/\"//g')
+OS_VERSION_ID=$(grep '^VERSION_ID=' /etc/os-release | cut -f2- -d= | sed -e 's/\"//g')
+OS_ARCH=$(uname -m)
+DRYRUN="${DRYRUN:-}"
+BUILD_RESULT="SUCCESSFULLY COMPLETED"
+BUILD_ERROR=""
+RETVAL="0"
+export CC=gcc
+
+make_build_release_build_test_gcov_sanity() {
+    if ! make UNATTENDED=yes install-dep ; then
+        BUILD_ERROR="FAILED 'make install-dep'"
+        return
+    fi
+    if ! make UNATTENDED=yes install-ext-deps ; then
+        BUILD_ERROR="FAILED 'make install-ext-deps'"
+        return
+    fi
+    if ! make UNATTENDED=yes build-release ; then
+        BUILD_ERROR="FAILED 'make build'"
+        return
+    fi
+    if ! make UNATTENDED=yes build ; then
+        BUILD_ERROR="FAILED 'make build'"
+        return
+    fi
+    if [ -n "${MAKE_PARALLEL_JOBS}" ] ; then
+        TEST_JOBS="${MAKE_PARALLEL_JOBS}"
+        echo "Testing VPP with ${TEST_JOBS} cores."
+    else
+        TEST_JOBS="auto"
+        echo "Testing VPP with automatically calculated number of cores. " \
+             "See test logs for the exact number."
+    fi
+    # TODO: Add 'smoke test' env var to select smoke test cases
+    #       then update this accordingly.  For now pick a few basic suites...
+    MAKE_TEST_SUITES="vlib vppinfra vpe_api vapi cli bihash"
+    for suite in $MAKE_TEST_SUITES ; do
+        if ! make UNATTENDED=yes TESTS_GCOV=1 TEST_JOBS="$TEST_JOBS" TEST=$suite test ; then
+            BUILD_ERROR="FAILED 'make TESTS_GCOV=1 TEST_JOBS=$TEST_JOBS TEST=$suite test'!"
+            return
+        fi
+        if ! make UNATTENDED=yes TESTS_GCOV=1 TEST_JOBS="$TEST_JOBS" TEST=$suite test-debug ; then
+            BUILD_ERROR="FAILED 'make TESTS_GCOV=1 TEST_JOBS=$TEST_JOBS TEST=$suite test-debug'!"
+            return
+        fi
+    done
+}
+
+if [ "${DRYRUN,,}" != "true" ] ; then
+    make_build_release_build_test_gcov_sanity
+fi
+if [ -n "$BUILD_ERROR" ] ; then
+    BUILD_RESULT="$BUILD_ERROR"
+    RETVAL="1"
+fi
+echo -e "\n$line\n* VPP ${OS_ID^^}-${OS_VERSION_ID}-${OS_ARCH^^} GCC BUILD $BUILD_RESULT\n$line\n"
+exit $RETVAL
index 585c3b1..c029128 100644 (file)
     executor-arch: 'x86_64'
 # [end] VPP-X86_64 PROJECT
 
-# [end] VPP-COV-X86_64 PROJECT
+# VPP-GCC-X86_64 PROJECT
+- project:
+    name: vpp-gcc-x86_64
+    jobs:
+      - 'vpp-gcc-verify-{stream}-{os}-{executor-arch}'
+    project: 'vpp'
+    make-parallel-jobs: '4'
+    os:
+      - ubuntu2004
+      - ubuntu2204
+    executor-arch: 'x86_64'
+    stream:
+      - 'master':
+          branch: 'master'
+          branch-refspec: ''
+      - '2210':
+          branch: 'stable/2210'
+          branch-refspec: ''
+      - '2302':
+          branch: 'stable/2302'
+          branch-refspec: ''
+      - '2306':
+          branch: 'stable/2306'
+          branch-refspec: ''
+    exclude:
+      # os deprecated in 23.06
+      - stream: '2306'
+        os: 'ubuntu2004'
+      # os deprecated in 23.02
+      - stream: '2302'
+        os: 'ubuntu2004'
+      # os deprecated in 22.10
+      - stream: '2210'
+        os: 'ubuntu2004'
+      # os deprecated in master
+      - stream: 'master'
+        os: 'ubuntu2004'
+
+# [end] VPP-GCC-X86_64 PROJECT
 
 # VPP-DEBUG-X86_64 PROJECT
 #
     os: 'ubuntu2004'
     executor-arch: 'x86_64'
 
+# [end] VPP-COV-X86_64 PROJECT
+
 # VPP-AARCH64 PROJECT
 #
 # NOTE: The list of supported branches for each OS are maintained
       - fdio-infra-publish
 # [end] VPP-MERGE JOB TEMPLATE
 
+# VPP-GCC-VERIFY JOB TEMPLATE
+- job-template:
+    name: 'vpp-gcc-verify-{stream}-{os}-{executor-arch}'
+
+    project-type: freestyle
+    node: 'builder-{os}-prod-{executor-arch}'
+    concurrent: true
+
+    properties:
+      - lf-infra-properties:
+          build-days-to-keep: "{build-days-to-keep}"
+
+    # Please keep parameters in alphabetical order
+    parameters:
+      - gerrit-parameter:
+          branch: '{branch}'
+      - gerrit-refspec-parameter:
+          refspec: '{branch-refspec}'
+      - make-parallel-jobs-parameter:
+          make-parallel-jobs: '{make-parallel-jobs}'
+      - os-parameter:
+          os: '{os}'
+      - project-parameter:
+          project: '{project}'
+      - stream-parameter:
+          stream: '{stream}'
+
+    scm:
+      - gerrit-trigger-scm:
+          credentials-id: 'jenkins-gerrit-credentials'
+          refspec: '$GERRIT_REFSPEC'
+          choosing-strategy: 'gerrit'
+
+    wrappers:
+      - fdio-infra-wrappers:
+          build-timeout: 120
+
+    triggers:
+      - gerrit-trigger-checkstyle:
+          name: '{project}'
+          branch: '{branch}'
+
+    builders:
+      - shell:
+          !include-raw-escape:
+          - ../scripts/setup_executor_env.sh
+      - shell:
+          !include-raw-escape:
+          - ../scripts/setup_vpp_ubuntu_docker_test.sh
+      - shell:
+          !include-raw-escape:
+          - ../scripts/setup_vpp_ext_deps.sh
+      - shell:
+          !include-raw-escape:
+          - ../scripts/vpp/gcc-build.sh
+
+    publishers:
+      - fdio-infra-publish
+# [end] VPP-GCC-VERIFY JOB TEMPLATE
+
 # VPP-COV-VERIFY JOB TEMPLATE
 - job-template:
     name: 'vpp-cov-verify-{stream}-{os}-{executor-arch}'